#!/bin/bash
## Copy this line ##
source $(dirname $(realpath $0))/../include.sh
## end


cat > /etc/systemd/system/amiserv5.service <<-"EOF"
[Unit]
Description=Amiserv5 for CPBX5
Documentation=
Wants=network-online.target
After=asterisk.service

[Service]
User=root
Type=forking
PIDFile=/var/run/amiserv.pid
ExecStartPre=/bin/rm -f /var/run/amiserv.pid
ExecStart=/usr/bin/mono-service -l:/var/run/amiserv.pid /usr/share/amiserv5/AmiServ5Service.exe
Restart=on-failure
RestartSec=5
WorkingDirectory=/usr/share/amiserv5
KillMode=control-group
KillSignal=SIGKILL

[Install]
WantedBy=multi-user.target
EOF


cat > /etc/asterisk/ombutel/extensions__90-AmiServ5.conf <<-"EOF"
[Amiserv5Spy]
exten => s,1,NoOp(*** Spy via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER}, DEVICENAME=${DEVICENAME})
 same => n,GotoIf($["${DB(${TENANT}/extensions/${EXTENSION_NUMBER}/spyb)}"="yes"]?:skip_pwd)
 same => n,Set(EXTENSION_PASSWORD=${DB(${TENANT}/extensions/${EXTENSION_NUMBER}/password)})
 same => n,GotoIf($["${EXTENSION_PASSWORD}"=""]skip_pwd)
 same => n,Authenticate(${EXTENSION_PASSWORD},,${LEN(${EXTENSION_PASSWORD})},please-enter-the&extension&vm-password&followed_pound)
 same => n(skip_pwd),NoOp()
 same => n,ChanSpy(${DEVICENAME},sSq)
 same => n,Hangup()

[Amiserv5Whisper]
exten => s,1,NoOp(*** Whisper via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER}, DEVICENAME=${DEVICENAME})
 same => n,GotoIf($["${DB(${TENANT}/extensions/${EXTENSION_NUMBER}/spyb)}"="yes"]?:skip_pwd)
 same => n,Set(EXTENSION_PASSWORD=${DB(${TENANT}/extensions/${EXTENSION_NUMBER}/password)})
 same => n,GotoIf($["${EXTENSION_PASSWORD}"=""]skip_pwd)
 same => n,Authenticate(${EXTENSION_PASSWORD},,${LEN(${EXTENSION_PASSWORD})},please-enter-the&extension&vm-password&followed_pound)
 same => n(skip_pwd),NoOp()
 same => n,ChanSpy(${DEVICENAME},wsSq)
 same => n,Hangup()

[Amiserv5Barge]
exten => s,1,NoOp(*** Barge via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER}, DEVICENAME=${DEVICENAME})
 same => n,GotoIf($["${DB(${TENANT}/extensions/${EXTENSION_NUMBER}/spyb)}"="yes"]?:skip_pwd)
 same => n,Set(EXTENSION_PASSWORD=${DB(${TENANT}/extensions/${EXTENSION_NUMBER}/password)})
 same => n,GotoIf($["${EXTENSION_PASSWORD}"=""]skip_pwd)
 same => n,Authenticate(${EXTENSION_PASSWORD},,${LEN(${EXTENSION_PASSWORD})},please-enter-the&extension&vm-password&followed_pound)
 same => n(skip_pwd),NoOp()
 same => n,ChanSpy(${DEVICENAME},BsSq)
 same => n,Hangup()

[Amiserv5DNDOn]
exten => s,1,NoOp(*** DND on via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER}, DEVICENAME=${DEVICENAME})
 same => n,Set(DB(${TENANT}/diversions/${EXTENSION_NUMBER}/DND/enable)=yes)
 same => n,Set(DB(${TENANT}/diversions/${EXTENSION_NUMBER}/has_enable_diversions)=yes)
 same => n,Set(DEVICE_STATE(Custom:DND_${EXTENSION_NUMBER})=BUSY)
 same => n,System(/usr/share/ombutel/scripts/synchronizer "enable-DND" "${EXTENSION_NUMBER}")
 same => n,Set(PRESENCE_STATE(CustomPresence:${EXTENSION_NUMBER})=DND,,)
 same => n,Hangup()

[Amiserv5DNDOff]
exten => s,1,NoOp(*** DND off via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER}, DEVICENAME=${DEVICENAME})
 same => n,Set(DB(${TENANT}/diversions/${EXTENSION_NUMBER}/DND/enable)=no)
 same => n,Set(DEVICE_STATE(Custom:DND_${EXTENSION_NUMBER})=NOT_INUSE)
 same => n,System(/usr/share/ombutel/scripts/synchronizer "disable-DND" "${EXTENSION_NUMBER}")
 same => n,Set(PRESENCE_STATE(CustomPresence:${EXTENSION_NUMBER})=AVAILABLE,,) 
 same => n,Set(CALL_SOURCE=${EXTENSION_NUMBER})
 same => n,Gosub(sub-cf-checkall,s,1)
 same => n,Hangup()

[Amiserv5CFOn]
exten => s,1,NoOp(*** CF on via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER}, CFTYPE=${CFTYPE}, DESTINATION=${DESTINATION})
 same => n,Set(DB(${TENANT}/diversions/${EXTENSION_NUMBER}/${CFTYPE}/destination)=${DESTINATION})
 same => n,Set(DB(${TENANT}/diversions/${EXTENSION_NUMBER}/${CFTYPE}/enable)=yes)
 same => n,Set(DEVICE_STATE(Custom:${CFTYPE}_${EXTENSION_NUMBER})=BUSY)
 same => n,System(/usr/share/ombutel/scripts/synchronizer "set-${CFTYPE}" "${EXTENSION_NUMBER}" "${DESTINATION}")
 same => n,System(/usr/share/ombutel/scripts/synchronizer "enable-${CFTYPE}" "${EXTENSION_NUMBER}")
 same => n,Set(DB(${TENANT}/diversions/${EXTENSION_NUMBER}/has_enable_diversions)=yes)
 same => n,Hangup()

[Amiserv5CFOff]
exten => s,1,NoOp(*** CF on via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER}, CFTYPE=${CFTYPE}, DESTINATION=${DESTINATION})
 same => n,Set(DB(${TENANT}/diversions/${EXTENSION_NUMBER}/${CFTYPE}/enable)=no)
 same => n,Set(DEVICE_STATE(Custom:${CFTYPE}_${EXTENSION_NUMBER})=NOT_INUSE)
 same => n,System(/usr/share/ombutel/scripts/synchronizer "disable-${CFTYPE}" "${EXTENSION_NUMBER}")
 same => n,Set(DB(${TENANT}/diversions/${EXTENSION_NUMBER}/has_enable_diversions)=yes)
 same => n,Set(CALL_SOURCE=${EXTENSION_NUMBER})
 same => n,Gosub(sub-cf-checkall,s,1)
 same => n,Hangup()

[Amiserv5QueueLogin]
exten => s,1,NoOp(*** Login toutes queues via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER})
 same => n,Set(ACTION=${IF($["${CHOOSE}" = "1"]?login:logout)})
 same => n,Set(QUEUES=${DB(${TENANT}/queues)})
 same => n,GoSub(queue_login,s,1(${QUEUES},${EXTENSION_NUMBER}))
 same => n,hangup()

[Amiserv5QueueLogout]
exten => s,1,NoOp(*** Logout toutes queues via amiserv)
 same => n,NoOp(Parametres : TENANT=${TENANT}, EXTENSION_NUMBER=${EXTENSION_NUMBER})
 same => n,Set(ACTION=${IF($["${CHOOSE}" = "1"]?login:logout)})
 same => n,Set(QUEUES=${DB(${TENANT}/queues)})
 same => n,GoSub(queue_logout,s,1(${QUEUES},${EXTENSION_NUMBER}))
 same => n,hangup()
EOF


cat > /etc/asterisk/ombutel/manager__90-AmiServ5.conf <<-"EOF"
[ipconnect]
secret = Ipconnect@AMI
deny = 0.0.0.0/0.0.0.0
permit = 127.0.0.1/255.255.255.0
permit = 192.168.11.0/255.255.255.0
read = all
write = all
writetimeout = 5000
EOF


asterisk -rx "core reload"

$mysqlcmd < $SCRIPTPATH/db.sql

$mysqlcmd <<EOF
CREATE USER "amiserv5"@"localhost" IDENTIFIED BY "SCvhgjzsSdvhvS4";
CREATE USER "amiserv5"@"127.0.0.1" IDENTIFIED BY "SCvhgjzsSdvhvS4";
CREATE USER "amiserv5"@"::1" IDENTIFIED BY "SCvhgjzsSdvhvS4";
CREATE USER "amiserv5"@"%" IDENTIFIED BY "SCvhgjzsSdvhvS4";
GRANT SELECT,DELETE,UPDATE,INSERT ON amiserv5.* TO "amiserv5"@"localhost";
GRANT SELECT,DELETE,UPDATE,INSERT ON amiserv5.* TO "amiserv5"@"127.0.0.1";
GRANT SELECT,DELETE,UPDATE,INSERT ON amiserv5.* TO "amiserv5"@"::1";
GRANT SELECT,DELETE,UPDATE,INSERT ON amiserv5.* TO "amiserv5"@"%";
GRANT SELECT,DELETE,UPDATE,INSERT ON asterisk.* TO "amiserv5"@"localhost";
GRANT SELECT,DELETE,UPDATE,INSERT ON asterisk.* TO "amiserv5"@"127.0.0.1";
GRANT SELECT,DELETE,UPDATE,INSERT ON asterisk.* TO "amiserv5"@"::1";
GRANT SELECT,DELETE,UPDATE,INSERT ON asterisk.* TO "amiserv5"@"%";
GRANT SELECT,DELETE,UPDATE,INSERT ON ombutel.* TO "amiserv5"@"localhost";
GRANT SELECT,DELETE,UPDATE,INSERT ON ombutel.* TO "amiserv5"@"127.0.0.1";
GRANT SELECT,DELETE,UPDATE,INSERT ON ombutel.* TO "amiserv5"@"::1";
GRANT SELECT,DELETE,UPDATE,INSERT ON ombutel.* TO "amiserv5"@"%";
GRANT SELECT,DELETE,UPDATE,INSERT ON supervision3.* TO "amiserv5"@"localhost";
GRANT SELECT,DELETE,UPDATE,INSERT ON supervision3.* TO "amiserv5"@"127.0.0.1";
GRANT SELECT,DELETE,UPDATE,INSERT ON supervision3.* TO "amiserv5"@"::1";
GRANT SELECT,DELETE,UPDATE,INSERT ON supervision3.* TO "amiserv5"@"%";
GRANT SELECT,DELETE,UPDATE,INSERT ON chatplugin.* TO "amiserv5"@"localhost";
GRANT SELECT,DELETE,UPDATE,INSERT ON chatplugin.* TO "amiserv5"@"127.0.0.1";
GRANT SELECT,DELETE,UPDATE,INSERT ON chatplugin.* TO "amiserv5"@"::1";
GRANT SELECT,DELETE,UPDATE,INSERT ON chatplugin.* TO "amiserv5"@"%";
GRANT SELECT,DELETE,UPDATE,INSERT ON performance2.* TO "amiserv5"@"localhost";
GRANT SELECT,DELETE,UPDATE,INSERT ON performance2.* TO "amiserv5"@"127.0.0.1";
GRANT SELECT,DELETE,UPDATE,INSERT ON performance2.* TO "amiserv5"@"::1";
GRANT SELECT,DELETE,UPDATE,INSERT ON performance2.* TO "amiserv5"@"%";
FLUSH PRIVILEGES;
EOF

systemctl enable amiserv5
systemctl daemon-reload
php "$SCRIPTPATH/InstallAPIKeyOmbutel.php"

if [ "$OS" == "centos" ]
then
    $mysqlcmd amiserv5 -e "UPDATE utilisateurs SET password=(CONCAT(MD5(RAND()), MD5(RAND()))) WHERE login='admin';"
fi


mkdir -p "/etc/amiserv5"
cp "$SCRIPTPATH/../../Config.txt.template" /etc/amiserv5/Config.txt